/*    
    WinDVD Plugin for ATI Remote Wonder
    Copyright 2002-2003 Jonathan Zarate
	http://www.polarcloud.com
	info@polarcloud.com

    This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

    This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
	for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "stdafx.h"
#include "config.h"
#include "global.h"
#include "actioncodes.h"
#include "mixer.h"
extern "C" {
#include "ammo.h"
}

#define WINDVD_OLDVIDEO_CLASS "Afx:400000:8"
#define WINDVD_OLDVIDEO_TITLE "InterVideo WinDVD 4"

// 4.0 DXVA B11.083
#define WINDVD_VIDEO_CLASS "WinDVDClass"
//#define WINDVD_VIDEO_TITLE "InterVideo WinDVD 4"

// 4.5 DXVA B11.000
//#define WINDVDP_VIDEO_CLASS "WinDVDClass"
//#define WINDVDP_VIDEO_TITLE "InterVideo WinDVD Platinum"


HWND hWinDVD;
HWND hMainPanel;


BOOL APIENTRY DllMain(HINSTANCE hDLLInst, DWORD  dwReason, LPVOID) {
	if (dwReason == DLL_PROCESS_ATTACH) {
		hInst = hDLLInst;
		LoadConfig();
	}
    return TRUE;
}


// ugly... but SetForegroundWindow() will not work across processes without these
void ForceForeground(HWND hWnd) {
	DWORD a;
	DWORD It;

	if (IsIconic(hWnd)) ShowWindow(hWnd, SW_RESTORE);
	if (GetForegroundWindow() == hWnd) return;
	a = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	It = GetWindowThreadProcessId(hWnd, NULL);
	AttachThreadInput(a, It, TRUE);
	BringWindowToTop(hWnd);
	SetForegroundWindow(hWnd);
	AttachThreadInput(a, It, FALSE);
	SetForegroundWindow(hWnd);	// ?
}

void KeyDown(DWORD Code)
{
	if (Code & ACTF_KEY_CTRL) keybd_event(VK_CONTROL, 0, 0, 0);
//	if (Code & ACTF_KEY_ALT) keybd_event(VK_MENU, 0, 0, 0);
//	if (Code & ACTF_KEY_SHIFT) keybd_event(VK_LSHIFT, 0, 0, 0);
	keybd_event((BYTE)(Code & ACTF_KEY_VALUE_MASK), 0, 0, 0);
	keybd_event((BYTE)(Code & ACTF_KEY_VALUE_MASK), 0, KEYEVENTF_KEYUP, 0);
//	if (Code & ACTF_KEY_SHIFT) keybd_event(VK_LSHIFT, 0, KEYEVENTF_KEYUP, 0);
//	if (Code & ACTF_KEY_ALT) keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0);
	if (Code & ACTF_KEY_CTRL) keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
}

DWORD WhatKeysDoYouWant(void) {
	return (CUSTOM_RAW|MOUSE_GROUP|CHANNEL_GROUP|VOLUME_GROUP|NUMBER_GROUP|
		CURSOR_GROUP|PLAY_GROUP|MENU|SETUP|ENTER|RECORD|STOPWATCH|RESIZE|WEB_LAUNCH);
}

char *EnumerateProgrammableFunction(WORD wIndex) {	
	return NULL;
}

void Configure(HWND hWnd) {
	ConfigDialog(hWnd);
}


// Find the main playback panel
bool FindMainPanel(void) {
	if ((hMainPanel = FindWindowEx(hWinDVD, NULL, "Afx:400000:8", "Player")) != NULL)
		return true;

	hMainPanel = NULL;
	while ((hMainPanel = FindWindowEx(NULL, hMainPanel, "Afx:400000:8", "Player")) != NULL) {
        if (GetWindowLong(hMainPanel, GWL_HWNDPARENT) == (LONG)hWinDVD)
			return true;
	}
	return false;
}

// Find a sub-panel based on its children's control titles.
HWND FindSubPanel(const char* Title) {
	HWND hPanel;

	// Find the playback panel first
	if (!FindMainPanel()) return NULL;

	// There are several sub-panels here and they all look alike. Go through their
	// children and look for an id unique to the sub-panel we want.
	// (note to self: newer versions seems to have titles now)
	hPanel = GetWindow(hMainPanel, GW_CHILD);
	while (hPanel) {
		if (FindWindowEx(hPanel, NULL, NULL, Title)) break;
		hPanel = GetWindow(hPanel, GW_HWNDNEXT);
	}
	return hPanel;
}

// WinDVD doesn't have a complete Angle/Audio/Subtitle cycle feature,
// so make one up.
void CycleGizmo(const char* MarkerTitle, DWORD dwPrevButton, DWORD dwNextButton, DWORD dwFirstMsg) {
	HWND hWnd;

	if ((hWnd = FindSubPanel(MarkerTitle)) == NULL) return;

	// if "next" button is enabled, push it
	if (IsWindowEnabled(GetDlgItem(hWnd, dwNextButton))) {	
		PostMessage(hWnd, WM_COMMAND, dwNextButton, 0);
	}
	// otherwise, if "previous" button is enabled, send dwFirstMsg
	else if (IsWindowEnabled(GetDlgItem(hWnd, dwPrevButton))) {	
		PostMessage(hWnd, WM_COMMAND, dwFirstMsg, 0);	
	}
}

// audio channel (left/right) "karaoke"
void AudioChannelCycle(void) {
	HWND hWnd;
	HWND hPanel;
	int n;

	if ((hPanel = FindSubPanel("DSP_Info")) != NULL) {
		if (((hWnd = GetDlgItem(hPanel, 0xCD)) != NULL) && (IsWindowEnabled(hWnd))) {
			n = ((SendMessage(hWnd, CB_GETCURSEL, 0, 0)+1) % SendMessage(hWnd, CB_GETCOUNT, 0, 0));
			SendMessage(hWnd, CB_SETCURSEL, n, 0);
			PostMessage(hWnd, WM_COMMAND, MAKELONG(0xCD, CBN_SELCHANGE), (LPARAM)hWnd);
		}
	}
}

// WinDVD Platinum (at least?) doesn't have the panel functions for selecting the drive
void DriveCycle(void) {
	HWND hWnd;
	HWND hPanel;
	int n;

	if ((hPanel = FindSubPanel("Chapter_List")) != NULL) {
		if (((hWnd = GetDlgItem(hPanel, 0xCF)) != NULL) && (IsWindowEnabled(hWnd))) {
			// get the count, minus "open file", "open playlist", "new playlist", and "dvd from folder"
			if ((n = SendMessage(hWnd, CB_GETCOUNT, 0, 0) - 4) <= 0) return;
			// select the next one...
			n = ((SendMessage(hWnd, CB_GETCURSEL, 0, 0)+1) % n);
			SendMessage(hWnd, CB_SETCURSEL, n, 0);
			PostMessage(hWnd, WM_COMMAND, MAKELONG(0xCF, CBN_SELCHANGE), (LPARAM)hWnd);
		}
	}
}


void TimeStretch(DWORD dwCmd) {
	HWND hWnd;

	// 848C	[button]	faster
	// 848D	[button]	slower
	// 8CC1	[msg]		normal time
	if ((hWnd = FindSubPanel("Time_Clock")) != NULL) 
		PostMessage(hWnd, WM_COMMAND, dwCmd, 0);
}

BOOL HandleKey (BOOL bCustom, WORD wKeyEvent, WORD wState) {
	HWND hWnd;
	DWORD ActionCode;

	// things that should not be here
	if (bCustom) return FALSE;
	if (wKeyEvent >= MAX_WONDER_KEYS) return FALSE;

	// Find WinDVD
	if ((hWinDVD = FindWindow(WINDVD_VIDEO_CLASS, NULL)) == NULL) {
		if ((hWinDVD = FindWindow(WINDVD_OLDVIDEO_CLASS, WINDVD_OLDVIDEO_TITLE)) == NULL)
			return FALSE;
	}

	// keycode -> actioncode
	ActionCode = ActionMap[wKeyEvent] & ~ACTF_ALTCODE;

	if (ActionCode == ACT_NONE) return FALSE;
	if (ActionCode == ACT_IGNORE) return TRUE;

	if (((wState == RMCTRL_KEY_ON) && ((ActionCode & ACTF_NO_DOWN) == 0)) ||
		((wState == RMCTRL_KEY_REPEAT) && (ActionCode & ACTF_ON_REPEAT)) ||
		((wState == RMCTRL_KEY_OFF) && (ActionCode & ACTF_ON_UP))) {
		switch (ActionCode & ACTF_F_MASK) {
		case ACTF_F_SPECIAL:
			switch (ActionCode) {
			case ACT_MIXVOLUP:
			case ACT_MIXVOLDN:
			case ACT_MIXVOLMUTE:
				MixerEvent(ActionCode, wState);
				break;
			case ACT_AUDIOLANG:
				// 8004		Previous_Audio Button
				// 8008+	Track 1 - 8
				// 8010		Next_Audio Button
				CycleGizmo("Audio_List", 0x8004, 0x8010, 0x8008);
				break;
			case ACT_SUBTITLE:
				// 8015		[button]	Previous_Subtitle
				// 8018-	[msg]		Subtitles 1 - ?
				// 8056		[msg]		Disable Subtitle
				// 8059		[button]	Next_Subtitle
				CycleGizmo("Subtitle_List", 0x8015, 0x8059, 0x8056);
				break;
			case ACT_ANGLE:
				//	8CB0	[button]	"Previous_Angle"
				//	8CB1	[button]	"Next_Angle"
				//	87F3+	[msg]		angle 1+
				CycleGizmo("Angle_List", 0x8CB0, 0x8CB1, 0x87F3);
				break;
			case ACT_AUDIOCHAN:
				AudioChannelCycle();
				break;
			case ACT_TSTRETCHNORM:
				TimeStretch(0x8CC1);
				break;
			case ACT_TSTRETCHFAST:
				TimeStretch(0x848C);
				break;
			case ACT_TSTRETCHSLOW:
				TimeStretch(0x848D);
				break;
			case ACT_ZOOM:
				if ((hWnd = FindSubPanel("Zoom")) != NULL) {
					PostMessage(hWnd, WM_COMMAND, 0x800B, 0);
				}
				return TRUE;
			case ACT_DRIVECYCLE:
				DriveCycle();
				break;
			case ACT_PLUGINSETUP:
				// note: this will block the remote!
				ConfigDialog(NULL);
				break;
			}
			break;
		case ACTF_F_KEYDOWN:
			if ((ActionCode & ACTF_KEY_NOSFW) == 0) ForceForeground(hWinDVD);
			KeyDown(ActionCode);
			break;
		case ACTF_F_WMCOMMAND:
			if ((hWnd = FindWindowEx(hWinDVD, NULL, "AfxOleControl42", "")) == NULL) return FALSE;
			PostMessage(hWnd, WM_COMMAND, MAKELONG((ActionCode & ACTF_WMCOMMAND_VALUE_MASK), 1), 0);
			break;
		}
	}

	return TRUE;
}

int AreYouInFocus (void) {
	HWND hForeground;
	if ((hWinDVD = FindWindow(WINDVD_VIDEO_CLASS, NULL)) == NULL) {
		if ((hWinDVD = FindWindow(WINDVD_OLDVIDEO_CLASS, WINDVD_OLDVIDEO_TITLE)) == NULL)
			return 0;
	}
	hForeground = GetForegroundWindow();
	return ((hForeground == hWinDVD) || (GetWindowLong(hForeground, GWL_HWNDPARENT) == (LONG)hWinDVD));
}

